#include <verilated.h>          // Defines common routines
#include <verilated_vcd_c.h>	// Trace file format header
#include "Vtest_top.h"

#include <iostream>

Vtest_top *top;                      // Instantiation of module

unsigned int main_time = 0;     // Current simulation time

double sc_time_stamp () {       // Called by $time in Verilog
    return main_time;
}

int main(int argc, char** argv)
{
    VerilatedVcdC* tfp = NULL;
    Verilated::commandArgs(argc, argv);   // Remember args

    top = new Vtest_top;             // Create instance

    if (1) {
	    Verilated::traceEverOn(true);
	    VL_PRINTF("Enabling waves...\n");
	    tfp = new VerilatedVcdC;
	    top->trace (tfp, 99);	// Trace 99 levels of hierarchy
	    tfp->open ("test_top.vcd");	// Open the dump file
    }

    while (!Verilated::gotFinish()) {
        if (main_time == 7000000) {
		VL_PRINTF("button off\n");
		top->v__DOT__button = 0;
        }
        if ((main_time % 10) == 1) {
            top->v__DOT__sysclk = 1;       // Toggle clock
        }
        if ((main_time % 10) == 6) {
            top->v__DOT__sysclk = 0;
        }
        top->eval();            // Evaluate model

	if (tfp) tfp->dump (main_time);

        main_time++;            // Time passes...
    }

    top->final();               // Done simulating

    if (tfp) tfp->close();
}
